## Cloned repo from https://github.com/micnews/story-json-to-stamp

# story-json-to-amp

Compile [story-json](https://github.com/micnews/story-json) documents into [AMP stories](https://github.com/ampproject/amphtml/blob/master/extensions/amp-story/amp-story.md).

Not all features of the `story-json` format are supported at the moment. Open an issue if you need something that isn't supported yet. PRs are always welcome!

## Usage

```js
import story from './story.json';
import storyJsonToAmp from 'story-json-to-amp';

const ampHtml = storyJsonToAmp(story);
```

## API

In addition to [standard `story-json` properties](https://github.com/micnews/story-json#document-properties), a few special optional properties can be added to the document:

| Name                         | Description                                                                                                       |
| ---------------------------- | ----------------------------------------------------------------------------------------------------------------- |
| `preview.publisher`          | REQUIRED. The name of the story's publisher.                                                                      |
| `preview.publisherLogoSrc`   | REQUIRED. The publisher's logo in square format (1x1 aspect ratio).                                               |
| `preview.posterPortraitSrc`  | REQUIRED. The story poster in portrait format (3x4 aspect ratio).                                                 |
| `preview.posterSquareSrc`    | The story poster in square format (1x1 aspect ratio).                                                             |
| `preview.posterLandscapeSrc` | The story poster in landscape format (4x3 aspect ratio).                                                          |
| `customCss`                  | Extra CSS to append to AMP story document. This is useful for adding fonts or making AMP-specific customizations. |
| `analytics`                  | Array of [AMP analytics objects](https://www.ampproject.org/docs/reference/components/amp-analytics)              |
| `bookendConfigSrc`           | [Bookend endpoint URL](https://www.ampproject.org/docs/tutorials/visual_story/create_bookend)                     |

## Example

Here's an AMP story generated by this module:

https://mic.com/stories/327/what-happens-in-your-brain-when-you-listen-to-music

## License

MIT
