'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ampStyleBoilerplatePlaceholder = undefined;

var _jsBeautify = require('js-beautify');

var _jsBeautify2 = _interopRequireDefault(_jsBeautify);

var _condenseNewlines = require('condense-newlines');

var _condenseNewlines2 = _interopRequireDefault(_condenseNewlines);

var _componentToHtmlTag = require('./component-to-html-tag');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var ampStyleBoilerplate = '<style amp-boilerplate>body{-webkit-animation:-amp-start 8s steps(1,end) 0s 1 normal both;-moz-animation:-amp-start 8s steps(1,end) 0s 1 normal both;-ms-animation:-amp-start 8s steps(1,end) 0s 1 normal both;animation:-amp-start 8s steps(1,end) 0s 1 normal both}@-webkit-keyframes -amp-start{from{visibility:hidden}to{visibility:visible}}@-moz-keyframes -amp-start{from{visibility:hidden}to{visibility:visible}}@-ms-keyframes -amp-start{from{visibility:hidden}to{visibility:visible}}@-o-keyframes -amp-start{from{visibility:hidden}to{visibility:visible}}@keyframes -amp-start{from{visibility:hidden}to{visibility:visible}}</style><noscript><style amp-boilerplate>body{-webkit-animation:none;-moz-animation:none;-ms-animation:none;animation:none}</style></noscript>';
var ampStyleBoilerplatePlaceholder = exports.ampStyleBoilerplatePlaceholder = '<div>REPLACE ME WITH AMP STYLE BOILERPLATE</div>';

var htmlOpts = {
  unformatted: ['code', 'pre', 'em', 'strong', 'span'],
  content_unformatted: ['pre'].concat(_toConsumableArray(Object.values(_componentToHtmlTag.textComponentToHtmlTagMap).map(String))),
  indent_inner_html: true,
  indent_char: ' ',
  indent_size: 2
};

var condenseOpts = {
  sep: '\n'
};

exports.default = function (html) {
  return (0, _condenseNewlines2.default)(_jsBeautify2.default.html(html, htmlOpts), condenseOpts)
  // Have to do this so that js-beautify doesn't add in pretty whitespace in the snippet,
  // thereby breaking AMP validation
  .replace(ampStyleBoilerplatePlaceholder, ampStyleBoilerplate);
};