'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _htmlTag = require('html-tag');

var _htmlTag2 = _interopRequireDefault(_htmlTag);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

exports.default = function (appendStyles) {
  return function (inlineStyles, text) {
    // TODO: make this more efficient
    if (!inlineStyles.length) {
      return text;
    }

    var inlineStylesWithClassName = inlineStyles.map(function (_ref) {
      var styles = _ref.styles,
          props = _objectWithoutProperties(_ref, ['styles']);

      var className = appendStyles(styles);

      return _extends({}, props, {
        className: className
      });
    });

    var getClassname = function getClassname(index) {
      return inlineStylesWithClassName.map(function (_ref2) {
        var className = _ref2.className,
            start = _ref2.start,
            length = _ref2.length;
        return index >= start && index < start + length && className;
      }).filter(Boolean).join(' ');
    };

    var latestTag = void 0;
    var tags = text.split('').reduce(function (accum, character, index) {
      var className = getClassname(index);

      if (index === 0 || className !== latestTag.className) {
        var newTag = {
          className: className,
          characters: []
        };
        accum.push(newTag);
        latestTag = newTag;
      }

      latestTag.characters.push(character);
      return accum;
    }, []);

    return tags.map(function (_ref3) {
      var className = _ref3.className,
          characters = _ref3.characters;

      var textString = characters.join('');

      return className ? (0, _htmlTag2.default)('span', { class: className }, textString) : textString;
    }).join('');
  };
};