'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _htmlTag = require('html-tag');

var _htmlTag2 = _interopRequireDefault(_htmlTag);

var _immutableObjectMethods = require('immutable-object-methods');

var _renderInlineStyles = require('./render-inline-styles');

var _renderInlineStyles2 = _interopRequireDefault(_renderInlineStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var noFlexTags = {
  'amp-story': true,
  'amp-story-page': true,
  'amp-story-grid-layer': true,
  'amp-story-bookend': true,
  'amp-story-auto-ads': true,
  'amp-video': true,
  source: true,
  h1: true,
  h2: true,
  h3: true,
  h4: true,
  h5: true,
  h6: true,
  p: true
};

exports.default = function (appendStyles) {
  var renderInlineStyles = (0, _renderInlineStyles2.default)(appendStyles);

  return function (tag, _ref) {
    var width = _ref.width,
        height = _ref.height,
        source = _ref.source,
        styles = _ref.styles,
        className = _ref.className,
        _ref$inlineStyles = _ref.inlineStyles,
        inlineStyles = _ref$inlineStyles === undefined ? [] : _ref$inlineStyles,
        props = _objectWithoutProperties(_ref, ['width', 'height', 'source', 'styles', 'className', 'inlineStyles']);

    var children = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';

    if (tag !== 'amp-story-grid-layer') delete props['template'];

    var tagStyles = noFlexTags[tag] ? styles : _extends({ display: 'flex' }, styles);

    var tagClassName = tagStyles && Object.keys(tagStyles).length > 0 && appendStyles(tagStyles);

    return (0, _htmlTag2.default)(tag, (0, _immutableObjectMethods.without)(_extends({}, props, {
      width: width && String(width),
      height: height && String(height),
      src: source,
      class: [tagClassName, className].filter(Boolean).join(' ') || undefined
    }), 'annotation'),
    // STAMP does not create newlines on \n or \r
    renderInlineStyles(inlineStyles, children).replace(/\r\n|\r|\n/g, '<br>'));
  };
};